import { StyleSheet } from 'fela-tools'
import { COLOR, TRANSITION } from '../../core/constants'
import transition from '../../rules/transition/transition'
import layout from '../../rules/layout/layout'

const CHECK_COLOR = COLOR.LEAF
const ERROR_COLOR = COLOR.CLAY

export default StyleSheet.create({
  wrapper: {
    userSelect: 'none'
  },
  input: {
    display: 'none'
  },
  label: {
    extend: layout()
  },
  icon: ({ checked, error }) => ({
    backgroundColor: checked ? CHECK_COLOR : COLOR.WHITE,
    color: checked ? COLOR.WHITE : COLOR.TRANSPARENT,
    cursor: 'pointer',
    marginRight: 8,
    flexShrink: 0,
    border: {
      color: error
        ? ERROR_COLOR
        : checked
          ? CHECK_COLOR
          : COLOR.STONE
    },
    extend: transition({
      property: 'background, color, border',
      duration: TRANSITION.UI.duration,
      easing: TRANSITION.UI.easing
    })
  })
})
