import { className, mergeData, renderRule, validate } from '../../core/utils'
import { EDGES } from '../../core/constants'
import rules from './space.rules'

const PROPERTIES = [ 'margin', 'padding' ]

export default {
  functional: true,
  inject: [
    'fela',
    'croudClassName'
  ],
  props: {
    tag: {
      type: String,
      default: 'div'
    },
    property: {
      type: String,
      enums: PROPERTIES,
      default: 'padding',
      validator: validate(PROPERTIES)
    },
    desktop: {
      type: Boolean,
      default: false
    },
    edges: {
      type: [ Array, String ],
      default: () => EDGES.ALL
    }
  },
  render(h, ctx) {
    const classes = renderRule(ctx, rules.space)
    return h(ctx.props.tag, mergeData(ctx, {
      class: className(ctx, 'space', classes)
    }), ctx.children)
  }
}
