import { className, mergeData, renderRule } from '../../core/utils'
import { EDGES } from '../../core/constants'
import rules from './table-row.rules'

export default {
  functional: true,
  inject: [
    'fela',
    'croudClassName'
  ],
  props: {
    tag: {
      type: String,
      default: 'div'
    },
    divider: {
      type: [ Boolean, String, Array ],
      default: () => EDGES.T
    },
    layout: {
      type: [ Boolean, Object ],
      default: true
    }
  },
  render(h, ctx) {
    const classes = renderRule(ctx, rules.row)
    return h(ctx.props.tag, mergeData(ctx, {
      class: className(ctx, 'table-row', classes)
    }), ctx.children)
  }
}
